Class WidgetServiceClient (0.1.0)

GitHub RepositoryProduct ReferenceRPC Documentation

Service Description: Provides APIs for widgets to interact with CES APIs.

This class provides the ability to make remote calls to the backing service through method calls that map to API methods. Sample code to get started:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (WidgetServiceClient widgetServiceClient = WidgetServiceClient.create()) {
   GenerateChatTokenRequest request =
       GenerateChatTokenRequest.newBuilder()
           .setName(SessionName.of("[PROJECT]", "[LOCATION]", "[APP]", "[SESSION]").toString())
           .setDeployment(
               DeploymentName.of("[PROJECT]", "[LOCATION]", "[APP]", "[DEPLOYMENT]").toString())
           .setRecaptchaToken("recaptchaToken1978277202")
           .build();
   GenerateChatTokenResponse response = widgetServiceClient.generateChatToken(request);
 }
 

Note: close() needs to be called on the WidgetServiceClient object to clean up resources such as threads. In the example above, try-with-resources is used, which automatically calls close().

Methods
Method Description Method Variants

GenerateChatToken

Generates a session scoped token for chat widget to authenticate with Session APIs.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • generateChatToken(GenerateChatTokenRequest request)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • generateChatTokenCallable()

ListLocations

Lists information about the supported locations for this service.This method can be called in two ways:

* **List all public locations:** Use the path GET /v1/locations.* **List project-visible locations:** Use the pathGET /v1/projects/{project_id}/locations. This may include publiclocations as well as private or other locations specifically visibleto the project.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • listLocations(ListLocationsRequest request)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • listLocationsPagedCallable()

  • listLocationsCallable()

GetLocation

Gets information about a location.

Request object method variants only take one parameter, a request object, which must be constructed before the call.

  • getLocation(GetLocationRequest request)

Callable method variants take no parameters and return an immutable API callable object, which can be used to initiate calls to the service.

  • getLocationCallable()

See the individual methods for example code.

Many parameters require resource names to be formatted in a particular way. To assist with these names, this class includes a format method for each type of name, and additionally a parse method to extract the individual identifiers contained within names that are returned.

This class can be customized by passing in a custom instance of WidgetServiceSettings to create(). For example:

To customize credentials:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 WidgetServiceSettings widgetServiceSettings =
     WidgetServiceSettings.newBuilder()
         .setCredentialsProvider(FixedCredentialsProvider.create(myCredentials))
         .build();
 WidgetServiceClient widgetServiceClient = WidgetServiceClient.create(widgetServiceSettings);
 

To customize the endpoint:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 WidgetServiceSettings widgetServiceSettings =
     WidgetServiceSettings.newBuilder().setEndpoint(myEndpoint).build();
 WidgetServiceClient widgetServiceClient = WidgetServiceClient.create(widgetServiceSettings);
 

To use REST (HTTP1.1/JSON) transport (instead of gRPC) for sending and receiving requests over the wire:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 WidgetServiceSettings widgetServiceSettings =
     WidgetServiceSettings.newHttpJsonBuilder().build();
 WidgetServiceClient widgetServiceClient = WidgetServiceClient.create(widgetServiceSettings);
 

Please refer to the GitHub repository's samples for more quickstart code snippets.

Inheritance

java.lang.Object > WidgetServiceClient

Static Methods

create()

public static final WidgetServiceClient create()

Constructs an instance of WidgetServiceClient with default settings.

Returns
Type Description
WidgetServiceClient
Exceptions
Type Description
IOException

create(WidgetServiceSettings settings)

public static final WidgetServiceClient create(WidgetServiceSettings settings)

Constructs an instance of WidgetServiceClient, using the given settings. The channels are created based on the settings passed in, or defaults for any settings that are not set.

Parameter
Name Description
settings WidgetServiceSettings
Returns
Type Description
WidgetServiceClient
Exceptions
Type Description
IOException

create(WidgetServiceStub stub)

public static final WidgetServiceClient create(WidgetServiceStub stub)

Constructs an instance of WidgetServiceClient, using the given stub for making calls. This is for advanced usage - prefer using create(WidgetServiceSettings).

Parameter
Name Description
stub WidgetServiceStub
Returns
Type Description
WidgetServiceClient

Constructors

WidgetServiceClient(WidgetServiceSettings settings)

protected WidgetServiceClient(WidgetServiceSettings settings)

Constructs an instance of WidgetServiceClient, using the given settings. This is protected so that it is easy to make a subclass, but otherwise, the static factory methods should be preferred.

Parameter
Name Description
settings WidgetServiceSettings

WidgetServiceClient(WidgetServiceStub stub)

protected WidgetServiceClient(WidgetServiceStub stub)
Parameter
Name Description
stub WidgetServiceStub

Methods

awaitTermination(long duration, TimeUnit unit)

public boolean awaitTermination(long duration, TimeUnit unit)
Parameters
Name Description
duration long
unit TimeUnit
Returns
Type Description
boolean
Exceptions
Type Description
InterruptedException

close()

public final void close()

generateChatToken(GenerateChatTokenRequest request)

public final GenerateChatTokenResponse generateChatToken(GenerateChatTokenRequest request)

Generates a session scoped token for chat widget to authenticate with Session APIs.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (WidgetServiceClient widgetServiceClient = WidgetServiceClient.create()) {
   GenerateChatTokenRequest request =
       GenerateChatTokenRequest.newBuilder()
           .setName(SessionName.of("[PROJECT]", "[LOCATION]", "[APP]", "[SESSION]").toString())
           .setDeployment(
               DeploymentName.of("[PROJECT]", "[LOCATION]", "[APP]", "[DEPLOYMENT]").toString())
           .setRecaptchaToken("recaptchaToken1978277202")
           .build();
   GenerateChatTokenResponse response = widgetServiceClient.generateChatToken(request);
 }
 
Parameter
Name Description
request GenerateChatTokenRequest

The request object containing all of the parameters for the API call.

Returns
Type Description
GenerateChatTokenResponse

generateChatTokenCallable()

public final UnaryCallable<GenerateChatTokenRequest,GenerateChatTokenResponse> generateChatTokenCallable()

Generates a session scoped token for chat widget to authenticate with Session APIs.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (WidgetServiceClient widgetServiceClient = WidgetServiceClient.create()) {
   GenerateChatTokenRequest request =
       GenerateChatTokenRequest.newBuilder()
           .setName(SessionName.of("[PROJECT]", "[LOCATION]", "[APP]", "[SESSION]").toString())
           .setDeployment(
               DeploymentName.of("[PROJECT]", "[LOCATION]", "[APP]", "[DEPLOYMENT]").toString())
           .setRecaptchaToken("recaptchaToken1978277202")
           .build();
   ApiFuture<GenerateChatTokenResponse> future =
       widgetServiceClient.generateChatTokenCallable().futureCall(request);
   // Do something.
   GenerateChatTokenResponse response = future.get();
 }
 
Returns
Type Description
UnaryCallable<GenerateChatTokenRequest,GenerateChatTokenResponse>

getLocation(GetLocationRequest request)

public final Location getLocation(GetLocationRequest request)

Gets information about a location.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (WidgetServiceClient widgetServiceClient = WidgetServiceClient.create()) {
   GetLocationRequest request = GetLocationRequest.newBuilder().setName("name3373707").build();
   Location response = widgetServiceClient.getLocation(request);
 }
 
Parameter
Name Description
request com.google.cloud.location.GetLocationRequest

The request object containing all of the parameters for the API call.

Returns
Type Description
com.google.cloud.location.Location

getLocationCallable()

public final UnaryCallable<GetLocationRequest,Location> getLocationCallable()

Gets information about a location.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (WidgetServiceClient widgetServiceClient = WidgetServiceClient.create()) {
   GetLocationRequest request = GetLocationRequest.newBuilder().setName("name3373707").build();
   ApiFuture<Location> future = widgetServiceClient.getLocationCallable().futureCall(request);
   // Do something.
   Location response = future.get();
 }
 
Returns
Type Description
UnaryCallable<com.google.cloud.location.GetLocationRequest,com.google.cloud.location.Location>

getSettings()

public final WidgetServiceSettings getSettings()
Returns
Type Description
WidgetServiceSettings

getStub()

public WidgetServiceStub getStub()
Returns
Type Description
WidgetServiceStub

isShutdown()

public boolean isShutdown()
Returns
Type Description
boolean

isTerminated()

public boolean isTerminated()
Returns
Type Description
boolean

listLocations(ListLocationsRequest request)

public final WidgetServiceClient.ListLocationsPagedResponse listLocations(ListLocationsRequest request)

Lists information about the supported locations for this service.This method can be called in two ways:

* **List all public locations:** Use the path GET /v1/locations.* **List project-visible locations:** Use the pathGET /v1/projects/{project_id}/locations. This may include publiclocations as well as private or other locations specifically visibleto the project.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (WidgetServiceClient widgetServiceClient = WidgetServiceClient.create()) {
   ListLocationsRequest request =
       ListLocationsRequest.newBuilder()
           .setName("name3373707")
           .setFilter("filter-1274492040")
           .setPageSize(883849137)
           .setPageToken("pageToken873572522")
           .build();
   for (Location element : widgetServiceClient.listLocations(request).iterateAll()) {
     // doThingsWith(element);
   }
 }
 
Parameter
Name Description
request com.google.cloud.location.ListLocationsRequest

The request object containing all of the parameters for the API call.

Returns
Type Description
WidgetServiceClient.ListLocationsPagedResponse

listLocationsCallable()

public final UnaryCallable<ListLocationsRequest,ListLocationsResponse> listLocationsCallable()

Lists information about the supported locations for this service.This method can be called in two ways:

* **List all public locations:** Use the path GET /v1/locations.* **List project-visible locations:** Use the pathGET /v1/projects/{project_id}/locations. This may include publiclocations as well as private or other locations specifically visibleto the project.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (WidgetServiceClient widgetServiceClient = WidgetServiceClient.create()) {
   ListLocationsRequest request =
       ListLocationsRequest.newBuilder()
           .setName("name3373707")
           .setFilter("filter-1274492040")
           .setPageSize(883849137)
           .setPageToken("pageToken873572522")
           .build();
   while (true) {
     ListLocationsResponse response = widgetServiceClient.listLocationsCallable().call(request);
     for (Location element : response.getLocationsList()) {
       // doThingsWith(element);
     }
     String nextPageToken = response.getNextPageToken();
     if (!Strings.isNullOrEmpty(nextPageToken)) {
       request = request.toBuilder().setPageToken(nextPageToken).build();
     } else {
       break;
     }
   }
 }
 
Returns
Type Description
UnaryCallable<com.google.cloud.location.ListLocationsRequest,com.google.cloud.location.ListLocationsResponse>

listLocationsPagedCallable()

public final UnaryCallable<ListLocationsRequest,WidgetServiceClient.ListLocationsPagedResponse> listLocationsPagedCallable()

Lists information about the supported locations for this service.This method can be called in two ways:

* **List all public locations:** Use the path GET /v1/locations.* **List project-visible locations:** Use the pathGET /v1/projects/{project_id}/locations. This may include publiclocations as well as private or other locations specifically visibleto the project.

Sample code:


 // This snippet has been automatically generated and should be regarded as a code template only.
 // It will require modifications to work:
 // - It may require correct/in-range values for request initialization.
 // - It may require specifying regional endpoints when creating the service client as shown in
 // https://cloud.google.com/java/docs/setup#configure_endpoints_for_the_client_library
 try (WidgetServiceClient widgetServiceClient = WidgetServiceClient.create()) {
   ListLocationsRequest request =
       ListLocationsRequest.newBuilder()
           .setName("name3373707")
           .setFilter("filter-1274492040")
           .setPageSize(883849137)
           .setPageToken("pageToken873572522")
           .build();
   ApiFuture<Location> future =
       widgetServiceClient.listLocationsPagedCallable().futureCall(request);
   // Do something.
   for (Location element : future.get().iterateAll()) {
     // doThingsWith(element);
   }
 }
 
Returns
Type Description
UnaryCallable<com.google.cloud.location.ListLocationsRequest,ListLocationsPagedResponse>

shutdown()

public void shutdown()

shutdownNow()

public void shutdownNow()